﻿/*////////// ================================================== ///////////

      <<<<<<<<<<<  FRIENDLY INTEGRATION by Bryson  >>>>>>>>>>>>>>>

	  -Created 09/12/08.
	  
	  -Last modified 09/22/08.
	  
	  -This project is free for all, do what you wish with it.
	  
	  -http://blog.sokay.net   ---   sonofbryce@sokay.net
	  
	  "I don't know bout you, but my scripts have actions."
	  
	  <<<<<<<<<<<<<<      when you know are       >>>>>>>>>>>>>>>>>

*/////////// ================================================== ///////////

package friendly {
	
	//  FLASH LIBRARIES
	import flash.display.MovieClip;
	import flash.events.*;
	
	// TWEENER
	import caurina.transitions.*;
	public class Actor extends MovieClip  {
		
		private var worldTarget:MovieClip;
		
		// are my keys down?
		private var keyHitUp:Boolean = false;
		private var keyHitDown:Boolean = false;
		private var keyHitLeft:Boolean = false;
		private var keyHitRight:Boolean = false;
		private var keyHit:Boolean = false;
		
		// keys mapped to keyCodes
		static const RIGHT = 39;
		static const LEFT = 37;
		static const UP = 38;
		static const DOWN = 40;
		static const SPACE = 32;
		static const PAUSE = 32;
		static const ADD = 107;
		static const SUB = 109;
		static const PGUP = 33;
		static const PGDN = 34;
		static const LEFTBRACKET = 188;
		static const RIGHTBRACKET = 190;
		
		static const KeyW = 87;
		static const KeyA = 65;
		static const KeyS = 83;
		static const KeyD = 68;
		
		private var player:int;
		
		private var playerTarget; // my true self
		
		private var playerSpeed:int = 8;
		private var playerState:String = "stand";
		private var playerHeight:int = 0;
		private var playerWidth:int = 0;
		
		private var xMax:int = 350;
		private var xMin:int = -350;
		private var yMax:int = 350;
		private var yMin:int = -400;
		
		private var facing = "right";
		private var jumpState = false;
		
		public function Actor(_worldTarget:MovieClip, _player:int){
			
			worldTarget = _worldTarget;
			
			player = _player;
			
			trace("Hello I am a Friendly Integrator");
			
		}
		
		function init(_playerTarget) {
			// init FN
			
			playerTarget = _playerTarget;
			
			if (player == 1) {
				x = -200;
				y = 0;
			} else {
				x = 200;
				y = 0;
			}
			
		}
		
		function act():void {
			//trace("Player acting");
			// movement
			if (getPlayerState() != "hurt") {
				if (keyHitLeft) {
					
					moveLeft();
					
				} else if (keyHitRight) {
					
					moveRight();
					
				}
				
				if (keyHitUp) {
					
					moveUp();
					
				} else if (keyHitDown) {
					
					moveDown();
					
				}
			}
			
			if (!keyHitLeft && !keyHitRight && !keyHitUp && !keyHitDown) {
				if (getPlayerState() != "hurt") {
					playerState = "stand";
				}
			}
			
		}
		
		//////////////////////////////////////////
		//
		//             MOVEMENT
		//
		//////////////////////////////////////////
		
		function moveX(_speed):void {
			
			//trace("I want to move X!");
			if (_speed > 0) {
				// moving right
				if (x + _speed < xMax - playerWidth) {
					x += _speed;
				} else {
					x = xMax - playerWidth;
				}
			} else if (_speed < 0) {
				// moving left
				if (x + _speed > xMin + playerWidth) {
					x += _speed;
				} else {
					x = xMin + playerWidth;
				}
			}
		}
		
		function moveY(_speed):void {
			
			//trace("I want to move Y!");
			if (_speed > 0) {
				// moving up
				if (y + _speed < yMax - playerHeight) {
					y += _speed;
				} else {
					y = yMax - playerHeight;
				}
			} else if (_speed < 0) {
				// moving down
				if (y + _speed > yMin + playerHeight) {
					y += _speed;
				} else {
					y = yMin + playerHeight;
				}
			}
		}
		
		function moveLeft():void {
			//trace("moveLeft()");
			// facing stuff
			if (facing != "left") {
				spinLeft();
			}
			facing = "left";
			if (scaleX > 0) {
				scaleX = -scaleX;
			}
			// movement
			moveX(-playerSpeed);
				
			if (getPlayerState() != "walking") {
				setPlayerState("walk");
			}
				
		}
		
		function moveRight():void {
			//trace("moveRight()");
			// facing stuff
			if (facing != "right") {
				spinRight();
			}
			facing = "right";
			if (scaleX < 0) {
				scaleX = -scaleX;
			}
			// movement
			moveX(playerSpeed);
			
			
			if (getPlayerState() != "walking") {
				setPlayerState("walk");
			}
			
		}
		
		function moveUp():void {
			//trace("moveUp()");
			// movement
			moveY(playerSpeed);
			
			if (getPlayerState() != "walking") {
				setPlayerState("walk");
			}
		}
		
		function moveDown():void {
			//trace("moveDown()");
			// movement
			moveY( -playerSpeed);
			
			if (getPlayerState() != "walking") {
				setPlayerState("walk");
			}
		}
		
		function spinLeft():void {
			Tweener.addTween(playerTarget, {rotationY:180, time:1.5,
						transition:"easeOutElastic"} );
		}
		
		function spinRight():void {
			Tweener.addTween(playerTarget, {rotationY:0, time:1.5,
						transition:"easeOutElastic"} );
		}
		
		//////////////////////////////////////////
		//
		//             GETTERS / SETTERS
		//
		//////////////////////////////////////////
		
		public function getPlayerState():String {
			return playerState;
		}
		
		public function setPlayerState(_state):void {
			playerState = _state;
		}
		
		
		
		
		//////////////////////////////////////////
		//
		//             KEY LISTENERS
		//
		//////////////////////////////////////////
		
		public function keyDownListener(e:KeyboardEvent):void {
			
			if (player == 1) {
			
				if (e.keyCode == RIGHT) {
					keyHitRight = true;
					if (!keyHit) {
						//moveRight();
						keyHit = true;
					}
				} else if (e.keyCode == LEFT) {
					keyHitLeft = true;
					if (!keyHit) {
						//moveLeft();
						keyHit = true;
					}
				}
				
				if (e.keyCode == UP) {
					keyHitUp = true;
					if (!keyHit) {
						//moveUp();
						keyHit = true;
					}
				} else if (e.keyCode == DOWN) {
					keyHitDown = true;
					if (!keyHit) {
						//moveDown();
						keyHit = true;
					}
				}
				
			} else if (player == 2) {
				
				if (e.keyCode == KeyD) {
					keyHitRight = true;
					if (!keyHit) {
						//moveRight();
						keyHit = true;
					}
				} else if (e.keyCode == KeyA) {
					keyHitLeft = true;
					if (!keyHit) {
						//moveLeft();
						keyHit = true;
					}
				}
				
				if (e.keyCode == KeyW) {
					keyHitUp = true;
					if (!keyHit) {
						//moveUp();
						keyHit = true;
					}
				} else if (e.keyCode == KeyS) {
					keyHitDown = true;
					if (!keyHit) {
						//moveDown();
						keyHit = true;
					}
				}
				
				
			}
			
			
			if (e.keyCode == SPACE) {
				//jump();
				if (player == 2) {
					if (!keyHit) {
						trace("hit");
						worldTarget.spawnItem();
						keyHit = true;
					}
				}
			}
			
			//trace("keyDown: "+e.keyCode +" , player: "+player);
		}
		
		
		// listen for keyUps!
		public function keyUpListener(e:KeyboardEvent):void {
			if (player == 1) {
				switch (e.keyCode) {
					case LEFT: 
						keyHitLeft = false;
						break;
					case RIGHT:
						keyHitRight = false;
						break;
					case UP:
						keyHitUp = false;
						break;
					case DOWN:
						keyHitDown = false;
						break;
				}
			} else if (player == 2) {
				switch (e.keyCode) {
					case KeyA: 
						keyHitLeft = false;
						break;
					case KeyD:
						keyHitRight = false;
						break;
					case KeyW:
						keyHitUp = false;
						break;
					case KeyS:
						keyHitDown = false;
						break;
				}
			}
			keyHit = false;

			//trace("keyUp");
		}
		
		
	}
	
}

/*
        --------------------
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        |------------------|
        |                  |
-------------------------------------
|||||||||||||||||||||||||||||||||||||
-------------------------------------
 |     / ///////\   //\\\\\ \     |
  \   /  ======\    /======  \   /
    \/--|  / \  ----  / \  |--\/
     |--|  \_/  ----  \_/  |--|
     |   ======/    \======   |
     |                        |
      \     /////  \\\\\     /
       \  \--------------/  /
        \  \  --------  /  /
         \  \/________\/  /
          -              -
           --------------

*/