﻿/*////////// ================================================== ///////////

      <<<<<<<<<<<  FRIENDLY INTEGRATION by Bryson  >>>>>>>>>>>>>>>

	  -Created 09/12/08.
	  
	  -Last modified 09/22/08.
	  
	  -This project is free for all, do what you wish with it.
	  
	  -http://blog.sokay.net   ---   sonofbryce@sokay.net
	  
	  "I don't know bout you, but my scripts have actions."
	  
	  <<<<<<<<<<<<<<      when you know are       >>>>>>>>>>>>>>>>>

*/////////// ================================================== ///////////

package friendly {
	
	//  FLASH LIBRARIES
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.filters.DropShadowFilter;
	
	// TWEENER - http://code.google.com/p/tweener/
	import caurina.transitions.*;
	
	// PAPERVISION ESSENTIALS
	import org.papervision3d.scenes.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.objects.special.*;
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.special.*;
	import org.papervision3d.materials.shaders.*;
	import org.papervision3d.materials.utils.*;
	import org.papervision3d.lights.*;
	import org.papervision3d.render.*;
	import org.papervision3d.view.*;
	import org.papervision3d.events.*;
	import org.papervision3d.core.utils.*;
	import org.papervision3d.core.utils.virtualmouse.VirtualMouse;
	
	// ETC
	import de.polygonal.math.PM_PRNG; // polygonal labs random number generator -- http://lab.polygonal.de/2007/04/21/a-good-pseudo-random-number-generator-prng/
	
	// PROJECT FILES
	import friendly.Actor;
	
	public class Friendly extends MovieClip	{
		
		// keys mapped to keyCodes
		static const RIGHT = 39;
		static const LEFT = 37;
		static const UP = 38;
		static const DOWN = 40;
		static const SPACE = 32;
		static const PAUSE = 32;
		static const ADD = 107;
		static const SUB = 109;
		static const PGUP = 33;
		static const PGDN = 34;
		static const LEFTBRACKET = 188;
		static const RIGHTBRACKET = 190;
		
		static const KeyW = 87;
		static const KeyA = 65;
		static const KeyS = 83;
		static const KeyD = 68;
		
		// SCENE

		var viewport:Viewport3D;

		var renderer:BasicRenderEngine = new BasicRenderEngine();

		var scene:Scene3D = new Scene3D();

		var camera:FreeCamera3D = new FreeCamera3D();

		var camTarget:DisplayObject3D = new DisplayObject3D();

		var anchor:DisplayObject3D = new DisplayObject3D();

		// this material is created from a bitmap file
		var matGroundPlane:BitmapFileMaterial = new BitmapFileMaterial("art/ground.png");
		
		//player 1
		var player1Skin = new Player1MC();
		var matplayer1_3d:MovieMaterial = new MovieMaterial(player1Skin, true, true, false );
		
		//player 2
		var player2Skin = new Player1MC();
		var matplayer2_3d:MovieMaterial = new MovieMaterial(player2Skin, true, true, false );
		
		
		//item
		var itemSkin = new ItemMC();
		var itemMaterial:MovieMaterial = new MovieMaterial(itemSkin, true, true, false );
		
		var explodeSkin = new ExplodeMC();
		var explodeMaterial:MovieMaterial = new MovieMaterial(explodeSkin, true, true, false );
		
		// shadow
		var shadow = new Shadow();
		var shadowMaterial:MovieMaterial = new MovieMaterial(shadow, true, false, false );
		
		// bush
		var bush = new Bush();
		var bushMaterial:MovieMaterial = new MovieMaterial(bush, true, false, false );
		
		// tree
		var tree = new Tree();
		var treeMaterial:MovieMaterial = new MovieMaterial(tree, true, false, false );
		
		// WALLS
		var wallBack_mc = new WallBack();
		var wallBackMaterial:MovieMaterial = new MovieMaterial(wallBack_mc, true, false, false );
		
		var wallLeft_mc = new WallLeft();
		var wallLeftMaterial:MovieMaterial = new MovieMaterial(wallLeft_mc, true, false, false );
		
		var wallRight_mc = new WallRight();
		var wallRightMaterial:MovieMaterial = new MovieMaterial(wallRight_mc, true, false, false );

		// OBJECTS
		////////////// CHARACTERS  /////////////////////////////
		var player1_3d:Plane = new Plane(matplayer1_3d, 100, 150, 3, 3);
		var player2_3d:Plane = new Plane(matplayer2_3d, 100, 150, 3, 3);
		
		var player1_3d_shadow:Plane = new Plane(shadowMaterial, 100, 100, 1, 1);
		var player2_3d_shadow:Plane = new Plane(shadowMaterial, 100, 100, 1, 1);
		
		/////////////// ENVIRONMENT ////////////////////////////
		var groundPlane:Plane = new Plane(matGroundPlane, 800, 800, 10, 10);
		var wallBack:Plane = new Plane(wallBackMaterial, 800, 800, 2, 2);
		var wallLeft:Plane = new Plane(wallLeftMaterial, 800, 800, 4, 1);
		var wallRight:Plane = new Plane(wallRightMaterial, 800, 800, 4, 1);
		
		var bush1:Plane = new Plane(bushMaterial, 300, 100, 1, 1);
		var bush2:Plane = new Plane(bushMaterial, 200, 70, 1, 1);
		var bush3:Plane = new Plane(bushMaterial, 220, 60, 1, 1);
		
		var tree1:Plane = new Plane(treeMaterial, 150, 300, 1, 1);
		var tree1_shadow:Plane = new Plane(shadowMaterial, 100, 100, 1, 1);
		
		var tree2:Plane = new Plane(treeMaterial, 150, 300, 1, 1);
		var tree2_shadow:Plane = new Plane(shadowMaterial, 100, 100, 1, 1);
		
		/////////////// ITEM ////////////////////////////
		
		var itemSize:int = 150;
		
		var item1_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var item2_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var item3_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		
		var item1_3d_shadow:Plane = new Plane(shadowMaterial, 50, 50, 2, 2);
		var item2_3d_shadow:Plane = new Plane(shadowMaterial, 50, 50, 2, 2);
		var item3_3d_shadow:Plane = new Plane(shadowMaterial, 50, 50, 2, 2);
		
		var bullet1_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var bullet2_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var bullet3_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var bullet4_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var bullet5_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		var bullet6_3d:Plane = new Plane(itemMaterial, itemSize, itemSize, 1, 1);
		
		var bullet1_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		var bullet2_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		var bullet3_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		var bullet4_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		var bullet5_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		var bullet6_3d_shadow:Plane = new Plane(shadowMaterial, 30, 30, 2, 2);
		
		var explode1_3d:Plane = new Plane(explodeMaterial, 200, 200, 2, 2);
		var explode2_3d:Plane = new Plane(explodeMaterial, 200, 200, 2, 2);
		
		//////////// VARS / SETTINGS ////////////

		var ground:Number = -200;
		var itemCount:int = 1;
		var bulletCount:int = 1;
		var bulletMax:int = 6;
		
		var player1Score:int = 0;
		var player2Score:int = 0;
		
		private var rand:PM_PRNG;
		
		// GAME STUFF
		public var player1:Actor;
		public var player2:Actor;
		
		var bullet1_spawn:Boolean = false;
		var bullet2_spawn:Boolean = false;
		var bullet3_spawn:Boolean = false;
		var bullet4_spawn:Boolean = false;
		var bullet5_spawn:Boolean = false;
		var bullet6_spawn:Boolean = false;
		
		var bullet1_target;
		var bullet2_target;
		var bullet3_target;
		var bullet4_target;
		var bullet5_target;
		var bullet6_target;
		
		
		var xmove:Number = 0;
		var zmove:Number = 0;
		
		var xmove1:Number = 0;
		var zmove1:Number = 0;
		
		var xmove2:Number = 0;
		var zmove2:Number = 0;
		
		var xmove3:Number = 0;
		var zmove3:Number = 0;
		
		var xmove4:Number = 0;
		var zmove4:Number = 0;
		
		var xmove5:Number = 0;
		var zmove5:Number = 0;
		
		var xmove6:Number = 0;
		var zmove6:Number = 0;
		
		
		public function Friendly() {
			trace("Hello, this is the Friendly Integration art experiment");
			
			// The game is started by a startGame() function call from within the "fade in" movieclip on the stage.
			
		}
		
		// OKAY!!! LET'S GET STARTED!
		
		public function startGame():void {
			
			rand = new PM_PRNG();
			rand.seed = 123;
			
			player1 = new Actor(this, 1);
			player2 = new Actor(this, 2);
			
			player1Skin.player = 1;
			player2Skin.player = 2;
			 
			loadScene();
			
			spawnItem();
			spawnItem();
			
			
			addChild(player1);
			player1.init(player1_3d);
			
			addChild(player2);
			player2.init(player2_3d);
			
			addChild(player1Skin);
			addChild(player2Skin);
			player1Skin.visible = false;
			player2Skin.visible = false;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownListener);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpListener);
			
		}

		function loadScene():void {
			
			stage.quality = "LOW";
			
			// SCENE
			viewport = new Viewport3D(myWindow.width, myWindow.height , false , false, true, false);
			myWindow.addChild(viewport);
			viewport.buttonMode = true;
			viewport.x = myWindow.x;
			viewport.y = myWindow.y;
			
			camera.zoom = 8;
			camera.focus = 50;
			camera.x = -0;
			camera.y = 50;
			camera.z = -700;
			camera.rotationX = -10;
			
			//Tweener.addTween(camera, {x:-150, y:camera.y, z:camera.z, zoom:15, time:2, delay:1,
								// transition:"easeOutQuad"/*,
								 //onComplete:transitionEnd*/ } );
			
			//OBJECTS
			
			scene.addChild(anchor);
			anchor.z = -100;
			
			/////////// player 1 ////////////
			
			anchor.addChild(player1_3d);
			player1_3d.material.doubleSided = true;
			//player1_3d.material.smooth = true;
			player1_3d.z = -60;
			player1_3d.x = -160;
			player1_3d.y = ground + 100;
			
			anchor.addChild(player1_3d_shadow);
			player1_3d_shadow.material.doubleSided = true;
			//player1_3d_shadow.material.smooth = true;
			player1_3d_shadow.z = -60;
			player1_3d_shadow.x = -160;
			player1_3d_shadow.y = ground + 20;
			player1_3d_shadow.rotationX = -90;
			
			/////////// player 2 ////////////
			
			anchor.addChild(player2_3d);
			player2_3d.material.doubleSided = true;
			//player1_3d.material.smooth = true;
			player2_3d.z = -60;
			player2_3d.x = 200;
			player2_3d.y = ground + 100;
			
			anchor.addChild(player2_3d_shadow);
			player2_3d_shadow.z = player2_3d.z;
			player2_3d_shadow.x = player2_3d.x;
			player2_3d_shadow.y = ground + 20;
			player2_3d_shadow.rotationX = -90;
			
			
			/////////// ENVIRONMENT  ////////////
			
			anchor.addChild(bush1);
			bush1.material.doubleSided = true;
			bush1.z = -375;
			bush1.y = ground + 70;
			bush1.x = -300;
			
			anchor.addChild(bush2);
			bush2.material.doubleSided = true;
			bush2.z = 75;
			bush2.y = ground + 60;
			bush2.x = -200;
			
			anchor.addChild(bush3);
			bush3.material.doubleSided = true;
			bush3.z = 0;
			bush3.y = ground + 60;
			bush3.x = -230;
			
			// tree 1			
			anchor.addChild(tree1);
			tree1.material.doubleSided = true;
			tree1.z = -150;
			tree1.y = ground + 150;
			tree1.x = 300;
			
			anchor.addChild(tree1_shadow);
			tree1_shadow.x = tree1.x;
			tree1_shadow.y = ground+10;
			tree1_shadow.z = tree1.z;
			tree1_shadow.rotationX = -90;
			
			// tree 2
			anchor.addChild(tree2);
			tree2.material.doubleSided = true;
			tree2.z = 350;
			tree2.y = ground + 150;
			tree2.x = -350;
			
			anchor.addChild(tree2_shadow);
			tree2_shadow.x = tree2.x;
			tree2_shadow.y = ground+10;
			tree2_shadow.z = tree2.z;
			tree2_shadow.rotationX = -90;
			
			////// GROUND & WALLS  ////////////////
			
			
			anchor.addChild(groundPlane);
			groundPlane.material.doubleSided = true;
			//groundPlane.material.smooth = true;
			groundPlane.z = 0;
			groundPlane.y = ground;
			groundPlane.rotationX = -90;
			
			/*
			anchor.addChild(wallBack);
			wallBack.material.doubleSided = true;
			//wallBack.material.smooth = true;
			wallBack.z = 400;
			wallBack.y = ground + 400;
			
			anchor.addChild(wallLeft);
			wallLeft.material.doubleSided = true;
			//wallLeft.material.smooth = true;
			wallLeft.x = -400;
			wallLeft.y = ground + 400;
			wallLeft.rotationY = 90;
			
			anchor.addChild(wallRight);
			wallRight.material.doubleSided = true;
			//wallRight.material.smooth = true;
			wallRight.x = 400;
			wallRight.y = ground + 400;
			wallRight.rotationY = 90;
			*/
			
			///////////// MISC /////////////
			
			player1_3d.addChild(camTarget);
			camTarget.y = player1_3d.y + 50;
			camTarget.x = player1_3d.x;
			camTarget.z = player1_3d.z;
			
			
			// GET THAT SHIT MOVIN!!!
			
			addEventListener(Event.ENTER_FRAME, act);
			
			
		}
		
		//////////////////////////////////////////
		//
		//           ENTER_FRAME (kinda important)
		//
		//////////////////////////////////////////

		function act(e:Event):void {
			
			////////// UPDATE HUD /////////////
			
			hud.p1Score.text = String(player1Score);
			hud.p2Score.text = String(player2Score);
			
			//////////////////////////////////
			
			camera.lookAt(camTarget);
			
			////////// PLAYER 1 ///////////
			
			player1.act();
			
			player1_3d.x = player1.x;
			player1_3d.z = player1.y;
			
			player1_3d_shadow.x = player1_3d.x;
			player1_3d_shadow.z = player1_3d.z;
			
			switch ( player1.getPlayerState() ) {
				case "walk":
					trace("walking");
					player1.setPlayerState("walking");
					player1Skin.gotoAndStop("walk");
					break;
				case "stand":
					player1Skin.gotoAndStop("stand");
					break;
				case "attack":
					player1Skin.gotoAndStop("attack");
					break;
			}
			
			////////// PLAYER 2 ////////////
			
			player2.act();
			
			player2_3d.x = player2.x;
			player2_3d.z = player2.y;
			
			player2_3d_shadow.x = player2_3d.x;
			player2_3d_shadow.z = player2_3d.z;
			
			switch ( player2.getPlayerState() ) {
				case "walk": 
					player2.setPlayerState("walking");
					player2Skin.gotoAndStop("walk");
					break;
				case "stand":
					player2Skin.gotoAndStop("stand");
					break;
				case "attack":
					player2Skin.gotoAndStop("attack");
					break;
			}
			
			///////////// CAM TARGET /////////
			
			camTarget.y = player1_3d.y + 50;
			//camTarget.x = player1_3d.x;
			//camTarget.z = player1_3d.z;
			
			midPoint(camTarget, player1_3d, player2_3d);
			
			/////////////  PAPERVISION RENDER  /////////////
			
			
			renderer.renderScene(scene, camera, viewport);
			
			
			
			///////////// BULLETS /////////
			
			if (bullet1_spawn) {
				bulletFly(1);
			}
			
			if (bullet2_spawn) {
				bulletFly(2);
			}
			
			if (bullet3_spawn) {
				bulletFly(3);
			}
			
			if (bullet4_spawn) {
				bulletFly(4);
			}
			
			if (bullet5_spawn) {
				bulletFly(5);
			}
			
			if (bullet6_spawn) {
				bulletFly(6);
			}
			
			
			
			///////////// COLLISIONS /////////
			
			if (itemCount >= 1) {
				if ( distance(item1_3d, player1_3d) < 50) {
					trace("collect item!");
					itemCollect("item1");
					spawnBullet(player1_3d, player2_3d);
				}
				
				if ( distance(item1_3d, player2_3d) < 50) {
					trace("collect item!");
					itemCollect("item1");
					spawnBullet(player2_3d, player1_3d);
				}
			}
			
			if (itemCount >= 2) {
				if ( distance(item2_3d, player1_3d) < 50) {
					trace("collect item!");
					itemCollect("item2");
					spawnBullet(player1_3d, player2_3d);
				}
				
				if ( distance(item2_3d, player2_3d) < 50) {
					trace("collect item!");
					itemCollect("item2");
					spawnBullet(player2_3d, player1_3d);
				}
			}
			
			if (itemCount >= 3) {
				if ( distance(item3_3d, player1_3d) < 50) {
					trace("collect item!");
					itemCollect("item3");
					spawnBullet(player1_3d, player2_3d);
				}
				
				if ( distance(item3_3d, player2_3d) < 50) {
					trace("collect item!");
					itemCollect("item3");
					spawnBullet(player2_3d, player1_3d);
				}
			}
			
		}
		
		private function keyDownListener(e:KeyboardEvent):void {
			player1.keyDownListener(e);
			player2.keyDownListener(e);
			
			if (e.keyCode == SPACE) {
				//spawnItem();
				explode(1);
			}
		}
		
		private function keyUpListener(e:KeyboardEvent):void {
			player1.keyUpListener(e);
			player2.keyUpListener(e);
		}
		
		//////////////////////////////////////////
		//
		//           GAME STUFFS
		//
		//////////////////////////////////////////
		
		function midPoint(_target, _mc1, _mc2):void {
			var midX = (_mc1.x + _mc2.x) / 2;
			var midZ = (_mc1.z + _mc2.z) / 2;
			
			_target.x = midX;
			_target.z = midZ;
		}
		
		function distance(_mc1, _mc2):int {
			var xDiff:Number = _mc1.x - _mc2.x;
			var zDiff:Number = _mc1.z - _mc2.z;
			
			var myDistance:int = Math.sqrt( Math.pow(xDiff, 2) + Math.pow(zDiff, 2) );
			
			//trace("myDistance: " + myDistance);
			
			return myDistance;
		}
		
		public function itemCollect(_item):void {
			var myTarget;
			var myTargetShadow;
			var myX:int = Math.floor(rand.nextDoubleRange( -350, 350));
			var	myZ:int = Math.floor(rand.nextDoubleRange( -350, 350));
			
			switch ( _item ) {
				case "item1": 
					myTarget = item1_3d;
					myTargetShadow = item1_3d_shadow;
					break;
				case "item2":
					myTarget = item2_3d;
					myTargetShadow = item2_3d_shadow;
					break;
				case "item3":
					myTarget = item3_3d;
					myTargetShadow = item3_3d_shadow;
					break;
			}
			
			myTarget.x = myX;
			myTarget.z = myZ;
			
			myTargetShadow.x = myX;
			myTargetShadow.z = myZ;

		}
		
		public function spawnItem():void {
			
			//trace("spawn item");
			
			var myX:int = Math.floor(rand.nextDoubleRange( -350, 350));
			var	myZ:int = Math.floor(rand.nextDoubleRange( -350, 350));
			var myY:int = ground + 75;
			
			trace("x: " + item1_3d.x + ", y: " + item1_3d.y + " , z: " + item1_3d.z );
			
			if (itemCount == 1) {
				
				anchor.addChild(item1_3d);
				item1_3d.y = myY;
				item1_3d.x =  myX;
				item1_3d.z =  myZ;
				
				anchor.addChild(item1_3d_shadow);
				item1_3d_shadow.y = ground + 20;
				item1_3d_shadow.x =  myX;
				item1_3d_shadow.z =  myZ;
				
				itemCount++;
				
			} else if (itemCount == 2) {
				
				
				
				anchor.addChild(item2_3d);
				item2_3d.y = myY;
				item2_3d.x =  myX;
				item2_3d.z =  myZ;
				
				anchor.addChild(item2_3d_shadow);
				item2_3d_shadow.y = ground + 20;
				item2_3d_shadow.x =  myX;
				item2_3d_shadow.z =  myZ;
				
				itemCount++;
				
			} else if (itemCount == 3) {
				
				anchor.addChild(item3_3d);
				item3_3d.y = myY;
				item3_3d.x = myX;
				item3_3d.z = myZ;
				
				anchor.addChild(item3_3d_shadow);
				item3_3d_shadow.y = ground + 20;
				item3_3d_shadow.x =  myX;
				item3_3d_shadow.z =  myZ;
				
				
				itemCount++;
			}
		}
		
		function spawnBullet(_shooter, _target):void {
			
			trace("spawnBullet()");
			
			var bulletTarget = this["bullet" + bulletCount + "_3d"];
			var bulletShadowTarget = this["bullet" + bulletCount + "_3d_shadow"];
			
			anchor.addChild(bulletTarget);
			bulletTarget.y = ground + 100;
			bulletTarget.x =  _shooter.x;
			bulletTarget.z =  _shooter.z;
			
			anchor.addChild(bulletShadowTarget);
			bulletShadowTarget.y = ground + 20;
			bulletShadowTarget.x =  bulletTarget.x;
			bulletShadowTarget.z =  bulletTarget.z;
			
			this["bullet" + bulletCount + "_spawn"] = true;
			
			this["bullet" + bulletCount + "_target"] = _target;
			
			follow(bulletTarget, _target)
			
			if (bulletCount < bulletMax) {
				bulletCount++;
			} else {
				bulletCount = 1;
			}
		}
		
		function bulletFly(_bullet):void {
			var bulletTarget = this["bullet" + _bullet + "_3d"];
			var bulletShadowTarget = this["bullet" + _bullet + "_3d_shadow"];
			
			bulletTarget.x += this["xmove" + _bullet];
			bulletTarget.z += this["zmove" + _bullet];
			
			bulletTarget.rotationZ += 15;
			
			bulletShadowTarget.x = bulletTarget.x;
			bulletShadowTarget.z = bulletTarget.z;
			
			if (this["bullet" + _bullet + "_target"] == player1_3d) {
				if ( distance(bulletTarget, player1_3d) < 50 ) {
					if (player1.getPlayerState() != "hurt") {
						explode(1);
						this["bullet" + _bullet + "_spawn"] = false;
						anchor.removeChild(bulletTarget);
						anchor.removeChild(bulletShadowTarget);
					}
				}
			} else if (this["bullet" + _bullet + "_target"] == player2_3d) {
				if ( distance(bulletTarget, player2_3d) < 50 ) {
					if (player2.getPlayerState() != "hurt") {
						explode(2);
						this["bullet" + _bullet + "_spawn"] = false;
						anchor.removeChild(bulletTarget);
						anchor.removeChild(bulletShadowTarget);
					}
				}
			}
		}
		
		function explode(_player):void {
			trace("explode!!!");
			if (_player == 1) {
				player2Score++;
				
				player1Skin.gotoAndStop("hurt");
				player1.setPlayerState("hurt");
				
				anchor.addChild(explode1_3d);
				explode1_3d.x = player1_3d.x;
				explode1_3d.y = player1_3d.y - 20;
				explode1_3d.z = player1_3d.z;
				player1.addEventListener(Event.ENTER_FRAME, explode1);
				
			} else if (_player == 2) {
				player1Score++;
				
				player2Skin.gotoAndStop("hurt");
				player2.setPlayerState("hurt");
				
				anchor.addChild(explode2_3d);
				explode2_3d.x = player2_3d.x;
				explode2_3d.y = player2_3d.y - 20;
				explode2_3d.z = player2_3d.z;
				player2.addEventListener(Event.ENTER_FRAME, explode2);
			}
		}
		
		function explode1(e:Event):void {
			explode1_3d.rotationZ += 5;
			explode1_3d.scaleX += .3;
			explode1_3d.scaleY += .3;
			explode1_3d.x += 15;
			
			if (explode1_3d.scaleX >= 3) {
				anchor.removeChild(explode1_3d);
				explode1_3d.scale = 1;
				explode1_3d.rotationZ = 0;
				player1.removeEventListener(Event.ENTER_FRAME, explode1);
			}
		}
		
		function explode2(e:Event):void {
			explode2_3d.rotationZ += 5;
			explode2_3d.scaleX += .3;
			explode2_3d.scaleY += .3;
			explode2_3d.x += 15;
			
			if (explode2_3d.scaleX >= 3) {
				anchor.removeChild(explode2_3d);
				explode2_3d.scale = 1;
				explode2_3d.rotationZ = 0;
				player2.removeEventListener(Event.ENTER_FRAME, explode2);
			}
		}
		
		function follow(_bullet, _target) {
			// lifted from LUV Tank, w/o the Z's  :)
			var speed = 8;
			var acc = 2;
			
			var dx = _target.x - _bullet.x;
			var dz = _target.z - _bullet.z;
			var dist = Math.sqrt(dx * dx + dz * dz);
			var xadd = acc * dx / dist;
			var zadd = acc * dz / dist;
			
			this["xmove" + bulletCount] = xadd;
			this["zmove" + bulletCount] = zadd;
			
			var totalmove = Math.sqrt(this["xmove" + bulletCount] * this["xmove" + bulletCount] + this["zmove" + bulletCount] * this["zmove" + bulletCount]);
			
			this["xmove" + bulletCount] = speed * this["xmove" + bulletCount] / totalmove;
			this["zmove" + bulletCount] = speed * this["zmove" + bulletCount] / totalmove;
			
			trace("xmove"+bulletCount+": " + this["xmove" + bulletCount] + ", zmove"+bulletCount+": " + this["zmove" + bulletCount] );
		}
		
	}
	
}

/*
        --------------------
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        ||||||||||||||||||||
        |------------------|
        |                  |
-------------------------------------
|||||||||||||||||||||||||||||||||||||
-------------------------------------
 |     / ///////\   //\\\\\ \     |
  \   /  ======\    /======  \   /
    \/--|  / \  ----  / \  |--\/
     |--|  \_/  ----  \_/  |--|
     |   ======/    \======   |
     |                        |
      \     /////  \\\\\     /
       \  \--------------/  /
        \  \  --------  /  /
         \  \/________\/  /
          -              -
           --------------

*/